.SS "OPENVSWITCH TUNNELING COMMANDS"
These commands query and modify OVS tunnel components.
.
.IP "\fBovs/route/add ipv4_address/plen output_bridge [GW]\fR"
Adds ipv4_address/plen route to vswitchd routing table. output_bridge
needs to be OVS bridge name.  This command is useful if OVS cached
routes does not look right.
.
.IP "\fBovs/route/show\fR"
Print all routes in OVS routing table, This includes routes cached
from system routing table and user configured routes.
.
.IP "\fBovs/route/del ipv4_address/plen\fR"
Delete ipv4_address/plen route from OVS routing table.
.
.IP "\fBtnl/neigh/show\fR"
.IP "\fBtnl/arp/show\fR"
OVS builds ARP cache by snooping are messages. This command shows
ARP cache table.
.
.IP "\fBtnl/neigh/set \fIbridge ip mac\fR"
.IP "\fBtnl/arp/set \fIbridge ip mac\fR"
Adds or modifies an ARP cache entry in \fIbridge\fR, mapping \fIip\fR
to \fImac\fR.
.
.IP "\fBtnl/neigh/flush\fR"
.IP "\fBtnl/arp/flush\fR"
Flush ARP table.
.
.IP "\fBtnl/neigh/aging [\fIseconds\fB]\fR"
.IP "\fBtnl/arp/aging [\fIseconds\fB]\fR"
Changes the aging time. The accepted values of \fIseconds\fR are
between 1 and 3600. The new entries will get the value as specified in
\fIseconds\fR. For the existing entries, the aging time is updated
only if the current expiration is greater than \fIseconds\fR.
.IP
If used without arguments, it prints the current aging value.
.
.IP "\fBtnl/egress_port_range [num1] [num2]\fR"
Set range for UDP source port used for UDP based Tunnels. For
example VxLAN. If case of zero arguments this command prints
current range in use.
